//+------------------------------------------------------------------+
//|                                                  Bears&Bulls.mq4 |
//|                                         Copyright  2008, Kharko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,   "

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Silver
//---- input parameters
extern int BearsBullsPeriod=13;
extern int SignalSMA=3; 
//---- buffers
double BearsBullsBuffer[];
double TempBuffer[];
double TempBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(3);
   IndicatorDigits(Digits);
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BearsBullsBuffer);
   SetIndexBuffer(1,TempBuffer);
   SetIndexBuffer(2,TempBuffer2);
//---- name for DataWindow and indicator subwindow label
   short_name="Bears&Bulls("+BearsBullsPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bears Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
//----
   if(Bars<=BearsBullsPeriod) return(0);
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      TempBuffer[i]=iMA(NULL,0,BearsBullsPeriod,0,MODE_EMA,PRICE_CLOSE,i);
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      TempBuffer2[i]=High[i]+Low[i]-2*TempBuffer[i];//BearsBullsBuffer[i]
      i--;
     }
   for(i=0; i<limit; i++)
      BearsBullsBuffer[i]=iMAOnArray(TempBuffer2,Bars,SignalSMA,0,MODE_SMA,i);  
//----
   return(0);
  }
//+------------------------------------------------------------------+